package net.binggl.lib.ajax.datatables;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * datatable compatible object
 * 
 * @author henrik
 * 
 */
public abstract class DataTableGenericResponse<T,M> implements Serializable {

	// member
	private List<T> aaData = new ArrayList<T>();
	private static final long serialVersionUID = 1L;
	private int sEcho = 0;
	private String iTotalRecords;
	private String iTotalDisplayRecords;
	
	/**
	 * @return the aaData
	 */
	public List<T> getAaData() {
		return this.getDataList();
	}

	/**
	 * set the data
	 * 
	 * @param items
	 * @param rowHandler
	 */
	public void setData(List<M> items, DataTableRowHandler<M, T> rowHandler) {
		T rowData = null;
		for (M item : items) {
			rowData = rowHandler.handleRow(item);
			if (rowData != null)
				this.getDataList().add(rowData);
		}
	}

	/**
	 * @return the sEcho
	 */
	public int getsEcho() {
		return sEcho;
	}

	/**
	 * @param sEcho
	 *            the sEcho to set
	 */
	public void setsEcho(int sEcho) {
		this.sEcho = sEcho;
	}

	/**
	 * @return the iTotalRecords
	 */
	public String getiTotalRecords() {
		return iTotalRecords;
	}

	/**
	 * @param iTotalRecords
	 *            the iTotalRecords to set
	 */
	public void setiTotalRecords(String iTotalRecords) {
		this.iTotalRecords = iTotalRecords;
	}

	/**
	 * @return the iTotalDisplayRecords
	 */
	public String getiTotalDisplayRecords() {
		return iTotalDisplayRecords;
	}

	/**
	 * @param iTotalDisplayRecords
	 *            the iTotalDisplayRecords to set
	 */
	public void setiTotalDisplayRecords(String iTotalDisplayRecords) {
		this.iTotalDisplayRecords = iTotalDisplayRecords;
	}

	/**
	 * get the internal data list
	 */
	protected List<T> getDataList() {
		return this.aaData;
	}
}
