package net.binggl.lib.crypt;

import java.security.Key;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;

import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

/**
 * helper class to perform symmetric AES encyption
 * 
 * @author henrik
 */
@SuppressWarnings("restriction")
public class AesEncryption {

	private static final String ALGORITHM = "AES";

	/**
	 * encrypt an input string
	 * @param secret
	 * @param input
	 * @return
	 * @throws Exception
	 */
	public static String encrypt(String secret, String input) throws Exception {
		Key key = generateKey(secret);
		Cipher c = Cipher.getInstance(ALGORITHM);
		c.init(Cipher.ENCRYPT_MODE, key);
		byte[] encValue = c.doFinal(input.getBytes());
		String encryptedValue = new BASE64Encoder().encode(encValue);
		return encryptedValue;
	}

	/**
	 * decrypt an input string
	 * @param secret
	 * @param encryptedValue
	 * @return
	 * @throws Exception
	 */
	public static String decrypt(String secret, String encryptedValue)
			throws Exception {
		Key key = generateKey(secret);
		Cipher c = Cipher.getInstance(ALGORITHM);
		c.init(Cipher.DECRYPT_MODE, key);
		byte[] decordedValue = new BASE64Decoder().decodeBuffer(encryptedValue);
		byte[] decValue = c.doFinal(decordedValue);
		String decryptedValue = new String(decValue);
		return decryptedValue;
	}

	
	
	/**
	 * generate a key object of a string secret
	 * @param stringKey
	 * @return
	 * @throws Exception
	 */
	private static Key generateKey(String stringKey) throws Exception {
		Key key = new SecretKeySpec(stringKey.getBytes(), ALGORITHM);
		return key;
	}
}