package net.binggl.lib.crypt;

import java.security.MessageDigest;
import org.apache.commons.codec.binary.Hex;


public class Crypt {
	
	final static String HashMethod = "MD5";
	final static String CharSet = "UTF-8";
	final static int HashLoops = 3;

	/**
	 * encrypt using AES
	 * @param message
	 * @param secretKey
	 * @return
	 * @throws Exception
	 */
	public static String encrypt(String message, String secretKey) throws Exception {
		String encrypted = "";
		String result = AesEncryption.encrypt(secretKey, message);

		if (result != null && !"".equals(result)) {
			// prepare the encrypted value, remove the \n and replace by
			// <br/>
			encrypted = result.replaceAll(System.getProperty("line.separator"),
					"<br/>");
		}
		return encrypted;
	}

	/**
	 * decrypt using AES
	 * @param message
	 * @param secretKey
	 * @return
	 * @throws Exception
	 */
	public static String decrypt(String message, String secretKey) throws Exception {
		String decryptedMessage = "";

		message = message.replaceAll("<br/>",
				System.getProperty("line.separator"));

		String result = AesEncryption.decrypt(secretKey, message);

		if (result != null && !"".equals(result)) {
			decryptedMessage = result;
		}

		return decryptedMessage;
	}
	
	/**
	 * create a hash value
	 * @param message
	 * @param salt
	 * @return
	 * @throws Exception
	 */
	public static String hash(String message, String salt) throws Exception {
		String hashtext = "";
		
		StringBuffer buffer = new StringBuffer();
		buffer.append(salt);
		buffer.append("_");
		buffer.append(message);
		
		MessageDigest messageDigest = MessageDigest.getInstance(HashMethod);
		byte[] resultByte = null;
		String content = "";
		for(int i=0;i<HashLoops;++i) {
			content = buffer.toString();
			
			messageDigest.reset();
			messageDigest.update(content.getBytes(CharSet));
			
			resultByte = messageDigest.digest();
			buffer.append(new String(Hex.encodeHex(resultByte)));
		}
		hashtext = new String(Hex.encodeHex(resultByte));
		
		return hashtext;
	}
}