/**
 * 
 */
package net.binggl.lib.test;

import static org.junit.Assert.*;

import net.binggl.lib.crypt.Crypt;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

/**
 * @author henrik
 *
 */
public class CryptTest {

	String secretKey = "1234567812345678";
	String plainText = "hello world of crypt";
	
	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	/**
	 * Test method for {@link net.binggl.lib.crypt.Crypt#encrypt(java.lang.String, java.lang.String)}.
	 * @throws Exception 
	 */
	@Test
	public void testEncrypt() throws Exception {
		String crypto = Crypt.encrypt(plainText, secretKey);
		assertNotNull(crypto);
		assertTrue(crypto.length() > 0);
		
		String decrypted = Crypt.decrypt(crypto, secretKey);
		assertNotNull(decrypted);
		assertTrue(plainText.equals(decrypted));
	}


	/**
	 * Test method for {@link net.binggl.lib.crypt.Crypt#hash(java.lang.String, java.lang.String)}.
	 * @throws Exception 
	 */
	@Test
	public void testHash() throws Exception {
		String hash = Crypt.hash(plainText, secretKey);
		assertNotNull(hash);
		assertTrue(hash.length() == 32);
	}

}
